<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: shape.hh Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('shape_8hh_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">shape.hh</div>  </div>
</div><!--header-->
<div class="contents">
<a href="shape_8hh.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_matrix_8hh.html">Matrix.hh</a>&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vector_8hh.html">Vector.hh</a>&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="class_shape.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_shape.html">Shape</a> {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;  <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_shape.html#aba30fe15a525b5f24e09829094213c07">   17</a></span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> <a class="code" href="class_shape.html#aba30fe15a525b5f24e09829094213c07">translation_</a>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_shape.html#afb6856641aa526f1371e5580e2cd7eb3">   22</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_shape.html#afb6856641aa526f1371e5580e2cd7eb3">angle_</a>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_shape.html#a0fa4498ed91a5b05434f99abe79dc86d">   29</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">double</span> <a class="code" href="class_shape.html#a0fa4498ed91a5b05434f99abe79dc86d">makeRadians</a>(<span class="keywordtype">double</span> degree) { <span class="keywordflow">return</span> degree * <a class="code" href="_matrix_8hh.html#a952eac791b596a61bba0a133a3bb439f">PI</a> / 180; }</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">   35</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <a class="code" href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">allCounter_</a> = 0;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">   40</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <a class="code" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">currentCounter_</a> = 0;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="class_shape.html#aaa8d87171e65e0d8ba3c5459978992a7">   47</a></span>&#160;    <a class="code" href="class_shape.html#aaa8d87171e65e0d8ba3c5459978992a7">Shape</a>() : <a class="code" href="class_shape.html#afb6856641aa526f1371e5580e2cd7eb3">angle_</a>{0} {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <a class="code" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">currentCounter_</a>++;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <a class="code" href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">allCounter_</a>++;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    };</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="class_shape.html#a499ab02e6fd00d35c87e9409cab672dc">   56</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_shape.html#a499ab02e6fd00d35c87e9409cab672dc">translate</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector3D</a> &amp;change) { <a class="code" href="class_shape.html#aba30fe15a525b5f24e09829094213c07">translation_</a> = <a class="code" href="class_shape.html#aba30fe15a525b5f24e09829094213c07">translation_</a> + change; }</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="class_shape.html#a4ab9606f25f5121c5d09e95de802f4c0">   62</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_shape.html#a4ab9606f25f5121c5d09e95de802f4c0">writeAngle</a>(<span class="keywordtype">double</span> change) { <a class="code" href="class_shape.html#afb6856641aa526f1371e5580e2cd7eb3">angle_</a> += change; }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_shape.html#adbb8b78656c05a402be46335239606ef">draw</a>(<span class="keyword">const</span> std::string &amp;filename) <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_shape.html#a23a2add7aced7879774dcbc91399cb6b">getCollisionInformation</a>() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    [[nodiscard]] <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="class_shape.html#a84f83422477236425ff566120e7e7c05">checkCollision</a>(<span class="keyword">const</span> std::vector&lt;Vector3D&gt; &amp;droneCover) <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="class_shape.html#a935afc9e576015f967d90de56977167d">   88</a></span>&#160;    <a class="code" href="class_shape.html#a935afc9e576015f967d90de56977167d">~Shape</a>() { <a class="code" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">currentCounter_</a>--; };</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;};</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_shape_html_a4ab9606f25f5121c5d09e95de802f4c0"><div class="ttname"><a href="class_shape.html#a4ab9606f25f5121c5d09e95de802f4c0">Shape::writeAngle</a></div><div class="ttdeci">void writeAngle(double change)</div><div class="ttdoc">Increase rotation angle.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00062">shape.hh:62</a></div></div>
<div class="ttc" id="aclass_shape_html_a23a2add7aced7879774dcbc91399cb6b"><div class="ttname"><a href="class_shape.html#a23a2add7aced7879774dcbc91399cb6b">Shape::getCollisionInformation</a></div><div class="ttdeci">virtual void getCollisionInformation() const =0</div><div class="ttdoc">Displays error message, that in the next step will be collision with something.</div></div>
<div class="ttc" id="aclass_shape_html_aaa8d87171e65e0d8ba3c5459978992a7"><div class="ttname"><a href="class_shape.html#aaa8d87171e65e0d8ba3c5459978992a7">Shape::Shape</a></div><div class="ttdeci">Shape()</div><div class="ttdoc">Constructor for Shape class.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00047">shape.hh:47</a></div></div>
<div class="ttc" id="aclass_shape_html_a84f83422477236425ff566120e7e7c05"><div class="ttname"><a href="class_shape.html#a84f83422477236425ff566120e7e7c05">Shape::checkCollision</a></div><div class="ttdeci">virtual bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const =0</div><div class="ttdoc">Checks if in the next step of movement will be collision with something.</div></div>
<div class="ttc" id="aclass_shape_html_a499ab02e6fd00d35c87e9409cab672dc"><div class="ttname"><a href="class_shape.html#a499ab02e6fd00d35c87e9409cab672dc">Shape::translate</a></div><div class="ttdeci">void translate(const Vector3D &amp;change)</div><div class="ttdoc">Increase translation vector.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00056">shape.hh:56</a></div></div>
<div class="ttc" id="aclass_shape_html_a935afc9e576015f967d90de56977167d"><div class="ttname"><a href="class_shape.html#a935afc9e576015f967d90de56977167d">Shape::~Shape</a></div><div class="ttdeci">~Shape()</div><div class="ttdoc">Destructor for Shape class.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00088">shape.hh:88</a></div></div>
<div class="ttc" id="a_matrix_8hh_html_a952eac791b596a61bba0a133a3bb439f"><div class="ttname"><a href="_matrix_8hh.html#a952eac791b596a61bba0a133a3bb439f">PI</a></div><div class="ttdeci">const double PI</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00008">Matrix.hh:8</a></div></div>
<div class="ttc" id="aclass_shape_html_a52b1f33f515746a215cd461bcd5e5d3f"><div class="ttname"><a href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">Shape::allCounter_</a></div><div class="ttdeci">static unsigned allCounter_</div><div class="ttdoc">Number of total Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00035">shape.hh:35</a></div></div>
<div class="ttc" id="aclass_shape_html_a0fa4498ed91a5b05434f99abe79dc86d"><div class="ttname"><a href="class_shape.html#a0fa4498ed91a5b05434f99abe79dc86d">Shape::makeRadians</a></div><div class="ttdeci">static double makeRadians(double degree)</div><div class="ttdoc">Calculate degrees to radians.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00029">shape.hh:29</a></div></div>
<div class="ttc" id="aclass_shape_html"><div class="ttname"><a href="class_shape.html">Shape</a></div><div class="ttdoc">Models the concept of the geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00012">shape.hh:12</a></div></div>
<div class="ttc" id="a_vector_8hh_html"><div class="ttname"><a href="_vector_8hh.html">Vector.hh</a></div></div>
<div class="ttc" id="aclass_shape_html_aa807a43b362e4ef73df68fe95813ec4a"><div class="ttname"><a href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">Shape::currentCounter_</a></div><div class="ttdeci">static unsigned currentCounter_</div><div class="ttdoc">Number of current Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00040">shape.hh:40</a></div></div>
<div class="ttc" id="aclass_shape_html_afb6856641aa526f1371e5580e2cd7eb3"><div class="ttname"><a href="class_shape.html#afb6856641aa526f1371e5580e2cd7eb3">Shape::angle_</a></div><div class="ttdeci">double angle_</div><div class="ttdoc">Rotation angle of geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00022">shape.hh:22</a></div></div>
<div class="ttc" id="a_matrix_8hh_html"><div class="ttname"><a href="_matrix_8hh.html">Matrix.hh</a></div></div>
<div class="ttc" id="aclass_shape_html_adbb8b78656c05a402be46335239606ef"><div class="ttname"><a href="class_shape.html#adbb8b78656c05a402be46335239606ef">Shape::draw</a></div><div class="ttdeci">virtual void draw(const std::string &amp;filename) const =0</div><div class="ttdoc">Saves the geometric object coordinates to a result file.</div></div>
<div class="ttc" id="aclass_shape_html_aba30fe15a525b5f24e09829094213c07"><div class="ttname"><a href="class_shape.html#aba30fe15a525b5f24e09829094213c07">Shape::translation_</a></div><div class="ttdeci">Vector3D translation_</div><div class="ttdoc">Translation vector of geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00017">shape.hh:17</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_0e6a83f483eb86bac30676662de98147.html">inc</a></li><li class="navelem"><a class="el" href="shape_8hh.html">shape.hh</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
